【leetcode】栈 Stack

1、leetcode225:用队列实现栈

使用队列实现栈的下列操作:

push(x) — 元素 x 入栈
pop() — 移除栈顶元素
top() — 获取栈顶元素
empty() — 返回栈是否为空

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
from queue import Queue

class MyStack:

def __init__(self):
self.q = Queue()

def push(self, x):
self.q.put(x)
# push 的时候把 x 放入队尾,然后遍历一遍原始队列元素,每次弹出之后加入队尾
for _ in range(self.q.qsize() - 1):
self.q.put(self.q.get())

def pop(self):
return self.q.get()

def top(self):
r = self.q.get()
self.q.put(r)
for _ in range(self.q.qsize() - 1):
self.q.put(self.q.get())
return r

def empty(self):
return not self.q.qsize()

obj = MyStack()
print(obj.empty())
obj.push(9)
obj.push(6)
obj.push(7)
print(obj.empty())
print(obj.top())
print(obj.pop())
print(obj.top())

2、leetcode232:用栈实现队列

使用栈实现队列的下列操作:

push(x) — 将一个元素放入队列的尾部。
pop() — 从队列首部移除元素。
peek() — 返回队列首部的元素。
empty() — 返回队列是否为空。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
class MyQueue:

def __init__(self):
self.stack1 = []
self.stack2 = []

def push(self, x):
# 两个栈倒,新来的元素总是在栈底(队尾进)
if self.stack1 == None:
self.stack1.append(x)
else:
while self.stack1:
self.stack2.append(self.stack1.pop(-1))
self.stack1.append(x)
while self.stack2:
self.stack1.append(self.stack2.pop(-1))

def pop(self):
# 直接弹出,因为本来就是队头出
return self.stack1.pop()

def peek(self):
if self.stack1:
return self.stack1[-1]

def empty(self):
# 因为队列1存储了所有元素,所以只需要判断队列1
return len(self.stack1) == 0

3、leetcode20:有效的括号

给定一个只包括 ‘(‘,’)’,’{‘,’}’,’[‘,’]’ 的字符串,判断字符串是否有效。
有效字符串需满足:
左括号必须用相同类型的右括号闭合。
左括号必须以正确的顺序闭合。
注意空字符串可被认为是有效字符串。

示例 1:
输入: “()”
输出: true

示例 2:
输入: “()[]{}”
输出: true

示例 3:
输入: “(]”
输出: false

示例 4:
输入: “([)]”
输出: false

示例 5:
输入: “{[]}”
输出: true

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
def isValid(s):
'''
利用栈先进先出的特性
'''
stack = []
judge = {'()','[]','{}'}
for i in s:
if not stack:
stack.append(i)
else:
if stack[-1]+i in judge:
stack.pop()
else:
stack.append(i)

return stack == []

print(isValid('()[]'))

4、删除最外层的括号

示例 :
输入:”(()())(())”
输出:”()()()”
解释:
输入字符串为 “(()())(())”,原语化分解得到 “(()())” + “(())”,
删除每个部分中的最外层括号后得到 “()()” + “()” = “()()()”。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
def removeOuterParentheses(S):
mark = 0
stack = []
for s in S:
if s == '(':
if mark != 0:
stack.append(s)
mark += 1
if s == ')':
mark -= 1
if mark != 0:
stack.append(s)
return ''.join(stack)

print(removeOuterParentheses("(()())(())"))

5、leetcode1047:删除字符串中的所有相邻重复项

给出由小写字母组成的字符串 S,重复项删除操作会选择两个相邻且相同的字母,并删除它们。
在 S 上反复执行重复项删除操作,直到无法继续删除。

示例:
输入:”abbaca”
输出:”ca”
解释:
例如,在 “abbaca” 中,我们可以删除 “bb” 由于两字母相邻且相同,这是此时唯一可以执行删除操作的重复项。之后我们得到字符串 “aaca”,其中又只有 “aa” 可以执行重复项删除操作,所以最后的字符串为 “ca”。

1
2
3
4
5
6
7
8
9
10
def removeDuplicates(S):
stack = [',']
for i in S:
if i == stack[-1]:
stack.pop()
else:
stack.append(i)
return ''.join(stack[1:])

print(removeDuplicates("abbaca"))

6、leetcode155:最小栈

设计一个支持 push,pop,top 操作,并能在常数时间内检索到最小元素的栈。

push(x) — 将元素 x 推入栈中。
pop() — 删除栈顶的元素。
top() — 获取栈顶元素。
getMin() — 检索栈中的最小元素。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
class MinStack:

# 辅助栈和数据栈同步
# 思路简单不容易出错

def __init__(self):
# 数据栈
self.data = []
# 辅助栈
self.helper = []

def push(self, x):
self.data.append(x)
if len(self.helper) == 0 or x <= self.helper[-1]:
self.helper.append(x)
else:
self.helper.append(self.helper[-1])

def pop(self):
if self.data:
self.helper.pop()
return self.data.pop()

def top(self):
if self.data:
return self.data[-1]

def getMin(self):
if self.helper:
return self.helper[-1]

7、leetcode496:下一个更大元素 I

给定两个没有重复元素的数组 nums1 和 nums2 ,其中nums1 是 nums2 的子集。找到 nums1 中每个元素在 nums2 中的下一个比其大的值。
nums1 中数字 x 的下一个更大元素是指 x 在 nums2 中对应位置的右边的第一个比 x 大的元素。如果不存在,对应位置输出-1。

示例 1:
输入: nums1 = [4,1,2], nums2 = [1,3,4,2].
输出: [-1,3,-1]
解释:
对于num1中的数字4,你无法在第二个数组中找到下一个更大的数字,因此输出 -1。
对于num1中的数字1,第二个数组中数字1右边的下一个较大数字是 3。
对于num1中的数字2,第二个数组中没有下一个更大的数字,因此输出 -1。

示例 2:
输入: nums1 = [2,4], nums2 = [1,2,3,4].
输出: [3,-1]
解释:
对于num1中的数字2,第二个数组中的下一个较大数字是3。
对于num1中的数字4,第二个数组中没有下一个更大的数字,因此输出 -1。

1
2
3
4
5
6
7
8
9
def nextGreaterElement(nums1, nums2):
stack, hashmap = list(), dict()
for i in nums2:
while len(stack) != 0 and stack[-1] < i:
hashmap[stack.pop()] = i
stack.append(i)
return [hashmap.get(i, -1) for i in nums1]

print(nextGreaterElement([4,1,2], [1,3,4,2]))

8、leetcode682:棒球比赛

你现在是棒球比赛记录员。
给定一个字符串列表,每个字符串可以是以下四种类型之一:

  • 整数(一轮的得分):直接表示您在本轮中获得的积分数。
  • “+”(一轮的得分):表示本轮获得的得分是前两轮有效 回合得分的总和。
  • “D”(一轮的得分):表示本轮获得的得分是前一轮有效 回合得分的两倍。
  • “C”(一个操作,这不是一个回合的分数):表示您获得的最后一个有效 回合的分数是无效的,应该被移除。

每一轮的操作都是永久性的,可能会对前一轮和后一轮产生影响。
你需要返回你在所有回合中得分的总和。

示例 1:
输入: [“5”,”2”,”C”,”D”,”+”]
输出: 30
解释:
第1轮:你可以得到5分。总和是:5。
第2轮:你可以得到2分。总和是:7。
操作1:第2轮的数据无效。总和是:5。
第3轮:你可以得到10分(第2轮的数据已被删除)。总数是:15。
第4轮:你可以得到5 + 10 = 15分。总数是:30。

示例 2:
输入: [“5”,”-2”,”4”,”C”,”D”,”9”,”+”,”+”]
输出: 27
解释:
第1轮:你可以得到5分。总和是:5。
第2轮:你可以得到-2分。总数是:3。
第3轮:你可以得到4分。总和是:7。
操作1:第3轮的数据无效。总数是:3。
第4轮:你可以得到-4分(第三轮的数据已被删除)。总和是:-1。
第5轮:你可以得到9分。总数是:8。
第6轮:你可以得到-4 + 9 = 5分。总数是13。
第7轮:你可以得到9 + 5 = 14分。总数是27。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
def calPoints(ops):
scores = []
total_score = 0
for s in ops:
if s == 'C':
total_score -= scores.pop()
elif s == 'D':
pre = scores[-1]
cur_score = 2 * pre
total_score += cur_score
scores.append(cur_score)
elif s == '+':
pre = scores.pop()
prepre = scores[-1]
cur_score = pre + prepre
total_score += cur_score
scores.append(pre)
scores.append(cur_score)
else:
cur_score = int(s)
total_score += cur_score
scores.append(cur_score)
return total_score

print(calPoints(["5","2","C","D","+"]))

9、leetcode844:比较含退格的字符串

给定 S 和 T 两个字符串,当它们分别被输入到空白的文本编辑器后,判断二者是否相等,并返回结果。 # 代表退格字符。

示例 1:
输入:S = “ab#c”, T = “ad#c”
输出:true
解释:S 和 T 都会变成 “ac”。
示例 2:

输入:S = “ab##”, T = “c#d#”
输出:true
解释:S 和 T 都会变成 “”。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
def backspaceCompare(S, T):
a = []
b = []
for i in range(len(S)):
if S[i] != '#':
a.append(S[i])
elif S[i] == '#' and a != []:
a.pop()
for i in range(len(T)):
if T[i] != '#':
b.append(T[i])
elif T[i] == '#' and b != []:
b.pop()
return a == b

print(backspaceCompare("ab#c", "ad#c"))